--[[
	SwitchToTrains.lua
	
	Author: 	mmc
	Date:		21.3.2018
	Version:	1.1 
	
	Changelog:
		Version 1.0.0.0 @ 15.3.2018 
			- Intial implementation.
]]


SwitchToTrains = {};

function SwitchToTrains:loadMap(name)
  Player.registerActionEvents = Utils.appendedFunction(Player.registerActionEvents, SwitchToTrains.registerActionEvents);
  Drivable.onRegisterActionEvents = Utils.appendedFunction(Drivable.onRegisterActionEvents, SwitchToTrains.registerActionEvents);
end;

function SwitchToTrains:registerActionEvents()
	local _, actionEventId = g_inputBinding:registerActionEvent('SWITCH_TO_TRAINS', self, SwitchToTrains.CycleTrain ,false ,true ,false ,true);
	g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_VERY_LOW)
end;

function SwitchToTrains:CycleTrain(actionName, keyStatus, arg3, arg4, arg5)

	-- Find usable trains.
	local trains = {};
	local currentTrainKey = nil;
	for key, vehicle in pairs(g_currentMission.vehicles) do
		if vehicle.spec_locomotive ~= nil then
			local myTrain = g_currentMission.controlledVehicle == vehicle
			if not vehicle:getIsInUse() or myTrain then
				trains[key] = vehicle;
				if myTrain then
					currentTrainKey = key;
				end;
			end;
		end;
	end;

	-- Find the next one in the cycle.
	local nextTrain = nil;
	table.sort(trains);
	_, nextTrain = next(trains, currentTrainKey);
	if nextTrain == nil then -- We hit the end of the cycle (or have no trains), go back and grab the first.
		_, nextTrain = next(trains, nil);
	end;

	-- Hop in!
	if nextTrain ~= nil then
			g_currentMission:requestToEnterVehicle(nextTrain);
	end;		

end;

function SwitchToTrains:onLoad(savegame)end;
function SwitchToTrains:onUpdate(dt)end;
function SwitchToTrains:deleteMap()end;
function SwitchToTrains:keyEvent(unicode, sym, modifier, isDown)end;
function SwitchToTrains:mouseEvent(posX, posY, isDown, isUp, button)end;
function SwitchToTrains:update(dt)end;
function SwitchToTrains:draw()end;

addModEventListener(SwitchToTrains);